#$Id: Makefile.inc,v 1.5 2003/11/29 12:17:21 vlad Exp $
#
# 3 proxy common Makefile
#

all:	pre  3proxy$(EXESUFFICS) mycrypt$(EXESUFFICS) dighosts$(EXESUFFICS) pop3p$(EXESUFFICS) tcppm$(EXESUFFICS) udppm$(EXESUFFICS) socks$(EXESUFFICS) proxy$(EXESUFFICS)


pre:
	@$(TYPECOMMAND)	License
	$(PREMAKE)


sockmap$(OBJSUFFICS): sockmap.c proxy.h
	$(CC) $(CFLAGS) sockmap.c

common$(OBJSUFFICS): common.c proxy.h
	$(CC) $(CFLAGS) common.c

base64$(OBJSUFFICS): base64.c
	$(CC) $(CFLAGS) base64.c

ftp$(OBJSUFFICS): ftp.c proxy.h
	$(CC) $(CFLAGS) ftp.c

#$(COMPATLIBS): 
#	$(CC) $(CFLAGS) strncasecmp.c

sockgetchar$(OBJSUFFICS): sockgetchar.c proxy.h
	$(CC) $(CFLAGS) sockgetchar.c

proxy$(OBJSUFFICS): proxy.c proxy.h proxymain.c
	$(CC) $(CFLAGS) $(DEFINEOPTION)WITHMAIN $(DEFINEOPTION)ANONYMOUS $(DEFINEOPTION)PORT=3128 proxy.c

pop3p$(OBJSUFFICS): pop3p.c proxy.h proxymain.c
	$(CC) $(CFLAGS) $(DEFINEOPTION)WITHMAIN $(DEFINEOPTION)PORT=110 pop3p.c

tcppm$(OBJSUFFICS): tcppm.c proxy.h proxymain.c
	$(CC) $(CFLAGS) $(DEFINEOPTION)WITHMAIN $(DEFINEOPTION)PORTMAP tcppm.c

socks$(OBJSUFFICS): socks.c proxy.h proxymain.c
	$(CC) $(CFLAGS) $(DEFINEOPTION)WITHMAIN $(DEFINEOPTION)PORT=1080 socks.c

udppm$(OBJSUFFICS): udppm.c proxy.h proxymain.c
	$(CC) $(CFLAGS) $(DEFINEOPTION)WITHMAIN $(DEFINEOPTION)PORTMAP $(DEFINEOPTION)UDP udppm.c

3proxy$(OBJSUFFICS): 3proxy.c proxy.h
	$(CC) $(CFLAGS) 3proxy.c


proxy$(EXESUFFICS): sockmap$(OBJSUFFICS) proxy$(OBJSUFFICS) sockgetchar$(OBJSUFFICS) common$(OBJSUFFICS) base64$(OBJSUFFICS) ftp$(OBJSUFFICS) $(COMPATLIBS)
	$(LN) $(LNOUT)proxy$(EXESUFFICS) $(LDFLAGS) $(VERFILE) sockmap$(OBJSUFFICS) proxy$(OBJSUFFICS) sockgetchar$(OBJSUFFICS) common$(OBJSUFFICS) base64$(OBJSUFFICS) ftp$(OBJSUFFICS) $(COMPATLIBS) $(LIBS)

pop3p$(EXESUFFICS): sockmap$(OBJSUFFICS) pop3p$(OBJSUFFICS) sockgetchar$(OBJSUFFICS) common$(OBJSUFFICS) $(COMPATLIBS)
	$(LN) $(LNOUT)pop3p$(EXESUFFICS) $(LDFLAGS) $(VERFILE) sockmap$(OBJSUFFICS) pop3p$(OBJSUFFICS) sockgetchar$(OBJSUFFICS) common$(OBJSUFFICS) $(COMPATLIBS) $(LIBS)

socks$(EXESUFFICS): sockmap$(OBJSUFFICS) socks$(OBJSUFFICS) sockgetchar$(OBJSUFFICS) common$(OBJSUFFICS)
	$(LN) $(LNOUT)socks$(EXESUFFICS) $(LDFLAGS) $(VERFILE) sockmap$(OBJSUFFICS) socks$(OBJSUFFICS) sockgetchar$(OBJSUFFICS)  common$(OBJSUFFICS) $(LIBS)

tcppm$(EXESUFFICS): sockmap$(OBJSUFFICS) tcppm$(OBJSUFFICS) common$(OBJSUFFICS)
	$(LN) $(LNOUT)tcppm$(EXESUFFICS) $(LDFLAGS) $(VERFILE) sockmap$(OBJSUFFICS) tcppm$(OBJSUFFICS) common$(OBJSUFFICS) $(LIBS)

udppm$(EXESUFFICS): sockmap$(OBJSUFFICS) udppm$(OBJSUFFICS) common$(OBJSUFFICS)
	$(LN) $(LNOUT)udppm$(EXESUFFICS) $(LDFLAGS) $(VERFILE) sockmap$(OBJSUFFICS) udppm$(OBJSUFFICS) common$(OBJSUFFICS) $(LIBS)

srvproxy$(OBJSUFFICS): proxy.c proxy.h proxymain.c
	$(CC) $(COUT)srvproxy$(OBJSUFFICS) $(CFLAGS) $(DEFINEOPTION)MODULEMAINFUNC=proxymain $(DEFINEOPTION)WITHMAIN $(DEFINEOPTION)PORT=3128 proxy.c

srvpop3p$(OBJSUFFICS): pop3p.c proxy.h proxymain.c
	$(CC) $(COUT)srvpop3p$(OBJSUFFICS) $(CFLAGS) $(DEFINEOPTION)MODULEMAINFUNC=pop3pmain $(DEFINEOPTION)WITHMAIN $(DEFINEOPTION)PORT=110 pop3p.c

srvtcppm$(OBJSUFFICS): tcppm.c proxy.h proxymain.c
	$(CC) $(COUT)srvtcppm$(OBJSUFFICS) $(CFLAGS) $(DEFINEOPTION)MODULEMAINFUNC=tcppmmain $(DEFINEOPTION)WITHMAIN $(DEFINEOPTION)PORTMAP tcppm.c

srvsocks$(OBJSUFFICS): socks.c proxy.h proxymain.c
	$(CC) $(COUT)srvsocks$(OBJSUFFICS) $(CFLAGS) $(DEFINEOPTION)MODULEMAINFUNC=socksmain $(DEFINEOPTION)WITHMAIN $(DEFINEOPTION)PORT=1080 socks.c

srvudppm$(OBJSUFFICS): udppm.c proxy.h proxymain.c
	$(CC) $(COUT)srvudppm$(OBJSUFFICS) $(CFLAGS) $(DEFINEOPTION)MODULEMAINFUNC=udppmmain $(DEFINEOPTION)WITHMAIN $(DEFINEOPTION)PORTMAP $(DEFINEOPTION)UDP udppm.c

auth$(OBJSUFFICS): auth.c proxy.h
	$(CC) $(COUT)auth$(OBJSUFFICS) $(CFLAGS) auth.c

mycrypt$(OBJSUFFICS): mycrypt.c
	$(CC) $(COUT)mycrypt$(OBJSUFFICS) $(CFLAGS) mycrypt.c

dighosts$(OBJSUFFICS): dighosts.c
	$(CC) $(COUT)dighosts$(OBJSUFFICS) $(CFLAGS) dighosts.c

dighosts$(EXESUFFICS): dighosts$(OBJSUFFICS) common$(OBJSUFFICS) sockgetchar$(OBJSUFFICS) $(COMPATLIBS)
	$(LN) $(LNOUT)dighosts$(EXESUFFICS) $(LDFLAGS) $(VERFILE) dighosts$(OBJSUFFICS) common$(OBJSUFFICS) sockgetchar$(OBJSUFFICS) $(COMPATLIBS) $(LIBS)

mycryptmain$(OBJSUFFICS): mycrypt.c
	$(CC) $(COUT)mycryptmain$(OBJSUFFICS) $(CFLAGS) $(DEFINEOPTION)WITHMAIN mycrypt.c

mycrypt$(EXESUFFICS): md4$(OBJSUFFICS) md5$(OBJSUFFICS) mycryptmain$(OBJSUFFICS)
	$(LN) $(LNOUT)mycrypt$(EXESUFFICS) $(VERFILE) $(LDFLAGS) md4$(OBJSUFFICS) md5$(OBJSUFFICS) mycryptmain$(OBJSUFFICS)


md4$(OBJSUFFICS):  libs/md4.h libs/md4.c
	$(CC) $(COUT)md4$(OBJSUFFICS) $(CFLAGS) libs/md4.c

md5$(OBJSUFFICS):  libs/md5.h libs/md5.c
	$(CC) $(COUT)md5$(OBJSUFFICS) $(CFLAGS) libs/md5.c

stringtable$(OBJSUFFICS):  stringtable.c
	$(CC) $(COUT)stringtable$(OBJSUFFICS) $(CFLAGS) stringtable.c

3proxy$(EXESUFFICS): 3proxy$(OBJSUFFICS) srvproxy$(OBJSUFFICS) srvpop3p$(OBJSUFFICS) srvsocks$(OBJSUFFICS) srvtcppm$(OBJSUFFICS) srvudppm$(OBJSUFFICS) sockmap$(OBJSUFFICS) sockgetchar$(OBJSUFFICS) common$(OBJSUFFICS) auth$(OBJSUFFICS) md4$(OBJSUFFICS) md5$(OBJSUFFICS) mycrypt$(OBJSUFFICS) base64$(OBJSUFFICS) ftp$(OBJSUFFICS) stringtable$(OBJSUFFICS) $(COMPATLIBS)
	$(LN) $(LNOUT)3proxy$(EXESUFFICS) $(LDFLAGS) $(VERFILE)  3proxy$(OBJSUFFICS) auth$(OBJSUFFICS) srvproxy$(OBJSUFFICS) srvpop3p$(OBJSUFFICS) srvsocks$(OBJSUFFICS) srvtcppm$(OBJSUFFICS) srvudppm$(OBJSUFFICS) sockmap$(OBJSUFFICS) sockgetchar$(OBJSUFFICS) common$(OBJSUFFICS) mycrypt$(OBJSUFFICS) md5$(OBJSUFFICS) md4$(OBJSUFFICS) base64$(OBJSUFFICS) ftp$(OBJSUFFICS) stringtable$(OBJSUFFICS) $(COMPATLIBS) $(LIBS)

clean:
	@$(REMOVECOMMAND) *$(OBJSUFFICS) $(COMPFILES)
